/*
 * Created on 30-set-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.opencms.core;

import java.sql.DriverManager;
import java.sql.SQLException;

import com.opencms.boot.I_CmsLogChannels;

import source.org.apache.java.util.Configurations;

/**
 * This class calls classic CmsDriver or DataSourceDriver<P>
 * To enable DataSourceDriver you need 3 additional configuration keys<br>
 * useDatasource = [true/false]<br>
 * jndiPrefix = prefix to jndi resources; using oc4j this's 'jdbc/', using tomcat it's 'java:/comp/env/jdbc/'<br> 
 * poolDebug = [0/1/2/3] for debugging pool directly into System.out<P>
 * Obviously you need to configure 3 datasources into your server, according to opencms naming<br>
 * To use Oracle on oc4j you need to create 3 datasources and set the ejb-location as "jdbc/oracleOci", "jdbc/oracleOcionline" and "jdbc/oracleOcibackup" <P>
 * If you use Oracle you need to replace oraclesql/CmsDbAccess.java with the new one provided
 * If you use Mysql you need to replace mySql/CmsDbAccess.java with the new one provided
 * 
 *<br>
 * Please note that you'll need to start oc4j with -userThreads option in order to
 * make context accessible to backup threads<br>
 * Also note that to enabling connection pooling you need to access datasources via ejb-location name<br>
 * 
 * @author Dariush Behboudi
 * @version $Revision: 1.00 $
 *
 * @see com.opencms.datasourcepool.DataSourceDriver
 * 

*/

public class DbDriverFactory implements  I_CmsConstants, I_CmsLogChannels{
	private static Configurations _conf = null;
	//private static Configurations c_config = null;
	public static void setConfigurations(Configurations conf) {
		_conf = conf;
		System.out.println ("useDataSource:" + conf.getString("useDataSource"));
		if (conf.getBoolean("useDataSource")) {
			System.out.println ("Using Datasource.");
			com.opencms.datasourcepool.DataSourceDriver.setConfigurations(conf);
		} else {
			System.out.println ("Using classic CmsDriver.");
			com.opencms.dbpool.CmsDriver.setConfigurations(conf);
		}
	}

	public static void destroy(String m_poolName)
		throws CmsException {
		try {
			if (_conf.getBoolean("useDataSource")) {
				// do nothing, Datasource think about that
			} else {
				((com.opencms.dbpool.CmsDriver) DriverManager.getDriver(m_poolName)).destroy();
				if(I_CmsLogChannels.C_PREPROCESSOR_IS_LOGGING && A_OpenCms.isLogging() ) {
					A_OpenCms.log(I_CmsLogChannels.C_OPENCMS_INIT, "[genericSql.CmsDbAccess] Destroyed");
				}
			}
		} catch(SQLException exc) {
			// destroy not possible - ignoring the exception
		}

	}
	
}
